#include <stdio.h>
#include <math.h>

unsigned numbits(unsigned long d)
{
    unsigned aux = 0;
    do
    {
        aux++;
        d >>= 1;
    } while (d);
    return aux-1;
}

unsigned bitset(int i, unsigned long d)
{
    int aux = ((d & (1L << i)) > 0);
    return aux;
}

unsigned long esm1(unsigned long C, unsigned long d, unsigned long n)
{
    register i, k;
    double aux;

    k = numbits(d);
    aux = C;
    for(i=k-1;i>=0;i--)
    {
        aux = fmod(aux * aux, n);
        if (bitset(i,d) == 1) aux = fmod(aux * C, n);
    }
    return aux;
}

void main(void)
{
    unsigned long d, e, n, p, q, phi, i, k;
    int f;

    printf("enter statring number for prime 1 p="); scanf("%lu", &p);
    f = 0;
    p++;
    while (!f) {
        if (p % 2) {
            k = sqrt(p);
            f = 1;
            for(i=3;i<=k;i++)
                if ((p % i) == 0)
                    f = 0;
        }
        p++;
    }
    p--;
    printf("first prime number generated p=%lu\n", p);

    printf("enter statring number for prime 1 q="); scanf("%lu", &q);
    f = 0;
    q++;
    while (!f) {
        if (q % 2) {
            k = sqrt(q);
            f = 1;
            for(i=3;i<=k;i++)
                if ((q % i) == 0)
                    f = 0;
        }
        q++;
    }
    q--;
    printf("first prime number generated q=%lu\n", q);

    n = p * q;
    phi = n - p - q + 1;
    printf("n=%lu phi=%lu\n", n, phi);
    d = q;
    do {
        f = 0;
        d++;
        while (!f) {
            if (d % 2) {
                k = sqrt(d);
                f = 1;
                for(i=3;i<=k;i++)
                    if ((d % i) == 0)
                        f = 0;
            }
            d++;
        }
        d--;
        printf("testing d=%lu", d);
        f = 0;
        i = 1;
        while (!f) {
            if ((((phi * i) + 1) % d) == 0) {
                e = ((phi * i) + 1) / d;
                printf(" e=%lu\n",e);
                f = 1;
            }
            if ((((phi * i) - 1) % d) == 0) {
                e = ((phi * i) - 1) / k;
                printf(" e=%lu\n",e);
                f = 1;
            }
            i++;
        }

    } while (esm1(esm1(0xF111,e,n),d,n) != 0xF111);

    printf("e=%lu d=%lu n=%lu\n",e,d,n);

    printf("key pairs (%lu,%lu) and (%lu,%lu)\n", e,n, d,n);
}

